/* priority.c -- (C) Geoffrey Reynolds, February 2007.

   Reduce process priority to idle.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
*/

#include "sr5sieve.h"
#include "config.h"

#if HAVE_SETPRIORITY
#include <sys/resource.h>
#elif defined(_WIN32) || defined(_WIN64)
#include <windows.h>
#endif

void set_idle_priority(void)
{
#if HAVE_SETPRIORITY
  /* This seems backwards, but PRIO_MAX refers to maximum niceness. */
  setpriority(PRIO_PROCESS,0,PRIO_MAX);
#elif defined(_WIN32) || defined(_WIN64)
  SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_IDLE);
#else
  /* Do nothing. */
#endif
}
